import { BasicColumn, FormSchema } from '@/components/Table';
import { h, Ref } from 'vue';
import { Switch } from 'ant-design-vue';
import { setRoleStatus } from '@/api/system/role/role';
import { useMessage } from '@/hooks/web/useMessage';
import { useRouter } from 'vue-router';

type CheckedType = boolean | string | number;
export const columns: BasicColumn[] = [
  {
    title: '操作时间',
    dataIndex: 'createDate',
    width: 200,
  },
  {
    title: '操作人',
    dataIndex: 'managerName',
    width: 100,
  },
  {
    title: '操作类型',
    dataIndex: 'manageType',
    width: 100,
  },
  {
    title: '对象名称',
    dataIndex: 'ObjectName',
    width: 200,
    // customRender: ({ record }) => {
    //   return h('a', {}, record.ObjectName);
    // },
  },
  // {
  //   title: '对象名称',
  //   dataIndex: 'ObjectName',
  //   width: 200,

  //   customRender: ({ record }) => {
  //     const router = useRouter(); // 获取路由实例
  //     return h(
  //       'a', // 使用 <a> 标签实现点击跳转
  //       {
  //         style: { color: '#1890ff', cursor: 'pointer' }, // 设置样式
  //         onClick: () => {
  //           router.push({
  //             path: '/dict/type/data', //改为要跳转的路径
  //             query: {
  //               dictType: record.dictType, //改为要转递的参数
  //             },
  //           });
  //         },
  //       },
  //       record.dictType,
  //     );
  //   },
  // },
  {
    title: '路径',
    dataIndex: 'url',
    width: 100,
  },
  {
    title: '对象类型',
    dataIndex: 'objectType',
    width: 100,
  },
  {
    title: '操作结果',
    dataIndex: 'result',
    width: 100,
  },
];
export const columnstab2: BasicColumn[] = [
  {
    title: '访问时间',
    dataIndex: 'createDate',
    width: 200,
  },
  {
    title: '访问用户',
    dataIndex: 'accessUser',
    width: 100,
  },
  {
    title: '访问途径',
    dataIndex: 'accessType',
    width: 100,
  },
  {
    title: '服务器IP/主机名',
    dataIndex: 'serverIp',
    width: 200,
  },
  {
    title: '数据源名称',
    dataIndex: 'dataSourceName',
    width: 100,
    // customRender: ({ record }) => {
    //   return h('a', {}, record.dataSourceName);
    // },
  },
  // {
  //   title: '数据源名称',
  //   dataIndex: 'dataSourceName',
  //   width: 100,
  //   customRender: ({ record }) => {
  //     const router = useRouter(); // 获取路由实例
  //     return h(
  //       'a', // 使用 <a> 标签实现点击跳转
  //       {
  //         style: { color: '#1890ff', cursor: 'pointer' }, // 设置样式
  //         onClick: () => {
  //           router.push({
  //             path: '/dict/type/data', //改为要跳转的路径
  //             query: {
  //               dictType: record.dictType, //改为要转递的参数
  //             },
  //           });
  //         },
  //       },
  //       record.dictType,
  //     );
  //   },
  // },
  {
    title: '数据源类型',
    dataIndex: 'dataSourceType',
    width: 100,
  },
  {
    title: '关联SQL语句',
    dataIndex: 'sql',
    width: 100,
  },
  {
    title: '执行结束时间',
    dataIndex: 'endTime',
    width: 100,
  },
  {
    title: '执行耗时',
    dataIndex: 'costTime',
    width: 100,
  },
  {
    title: '访问结果',
    dataIndex: 'result',
    width: 100,
  },
];

export const searchFormSchema: FormSchema[] = [
  {
    field: 'search',
    label: '',
    component: 'Input',
    componentProps: {
      placeholder: '搜索',
    },
    colProps: { span: 2 },
  },
  {
    field: 'objectType',
    label: '对象类型',
    component: 'Select',
    componentProps: {
      options: [
        { label: '对象类型1', value: '1' },
        { label: '对象类型2', value: '2' },
      ],
      placeholder: '请选择',
    },
    colProps: { span: 3 },
  },
  {
    field: 'manageType',
    label: '操作类型',
    component: 'Select',
    componentProps: {
      options: [
        { label: '操作类型1', value: '1' },
        { label: '操作类型2', value: '2' },
      ],
      placeholder: '请选择',
    },
    colProps: { span: 3 },
  },
  {
    field: 'manageResult',
    label: '操作结果',
    component: 'Select',
    componentProps: {
      options: [
        { label: '操作结果1', value: '1' },
        { label: '操作结果2', value: '2' },
      ],
      placeholder: '请选择',
    },
    colProps: { span: 3 },
  },
  {
    field: 'timeRange',
    label: '时间范围',
    component: 'RangePicker',
    componentProps: {
      placeholder: ['开始时间', '结束时间'],
    },
    colProps: { span: 6 },
  },
];
export const searchFormSchematab2: FormSchema[] = [
  {
    field: 'search',
    label: '',
    component: 'Input',
    componentProps: {
      placeholder: '搜索',
    },
    colProps: { span: 3 },
  },
  {
    field: 'dataSourceType',
    label: '数据源类型',
    component: 'Select',
    componentProps: {
      options: [
        { label: '数据源类型1', value: '1' },
        { label: '数据源类型2', value: '2' },
      ],
      placeholder: '请选择',
    },
    colProps: { span: 3 },
  },
  {
    field: 'accessResult',
    label: '访问结果',
    component: 'Select',
    componentProps: {
      options: [
        { label: '访问结果1', value: '1' },
        { label: '访问结果2', value: '2' },
      ],
      placeholder: '请选择',
    },
    colProps: { span: 3 },
  },
  {
    field: 'accessType',
    label: '访问途径',
    component: 'Select',
    componentProps: {
      options: [
        { label: '访问途径1', value: '1' },
        { label: '访问途径2', value: '2' },
      ],
      placeholder: '请选择',
    },
    colProps: { span: 3 },
  },
  {
    field: 'timeRange',
    label: '时间范围',
    component: 'RangePicker',
    componentProps: {
      placeholder: ['开始时间', '结束时间'],
    },
    colProps: { span: 5 },
  },
];

export const formSchema: FormSchema[] = [
  {
    field: 'ruleName',
    label: '规则名称',
    component: 'Input',
    rules: [
      {
        required: true,
        message: '请输入规则名称',
      },
    ],
  },
  {
    field: 'description',
    label: '规则描述',
    component: 'InputTextArea',
  },
  {
    field: 'roleStatus',
    label: '规则状态',
    component: 'Switch',
    defaultValue: false,
  },
  {
    field: 'resourceType',
    label: '资源类型',
    component: 'Select',
    componentProps: {
      options: [
        { label: '资源类型1', value: '1' },
        { label: '资源类型2', value: '2' },
      ],
    },
  },
  {
    field: 'alarmRange',
    label: '作用范围',
    component: 'Select',
    componentProps: {
      options: [
        { label: '元数据变更', value: '1' },
        { label: '元数据处理', value: '2' },
      ],
    },
    rules: [
      {
        required: true,
        message: '请选择作用范围',
      },
    ],
  },
  {
    field: 'triggerType',
    label: '触发方式',
    component: 'Select',
    componentProps: {
      options: [
        { label: '元数据变更', value: '1' },
        { label: '元数据处理', value: '2' },
      ],
    },
  },
  {
    field: 'alarmType',
    label: '通知方式',
    component: 'RadioGroup',
    componentProps: {
      options: [
        { label: '元数据变更', value: '1' },
        { label: '元数据处理', value: '2' },
      ],
    },
  },
  {
    field: 'alarmLevel',
    label: '紧急程度',
    component: 'Select',
    componentProps: {
      options: [
        { label: '紧急', value: '1' },
        { label: '不紧急', value: '2' },
      ],
    },
  },
];
